! mozi-koodo: EUC
! 06/1/25版
!     CalculiXのcgxで描いた応力図(最大値赤、中央値緑、最小値青)
!     をグレースケール化する。実は緑には手をつけてないんだけど、
!     これでうまくいってるかな。
!
        program ppmzeng
       implicit real*8 (a-h, o-z)
       dimension rgb3(3900000),r(3900000),g(3900000),b(3900000),
     & zy(3900000),zi(3900000),zq(3900000)
       character p3*2,mozi*44
          read(*,100) p3
100      format(a2)
           write(*,*) 'マジックナンバー：',p3
          read(*,*) mozi
          read(*,*) m,n
          write(*,*) '幅：',m
          write(*,*) '高さ：',n
           mn=m*n
          read(*,*) max
          write(*,*) '最大値：',max
          do i=1,mn
           read(*,*) rgb3((i-1)*3+1)
           read(*,*) rgb3((i-1)*3+2)
           read(*,*) rgb3((i-1)*3+3)
          end do
!
!  以上がデータ入力
!
        do i=1,mn
          r(i)=rgb3((i-1)*3+1)
          g(i)=rgb3((i-1)*3+2)
          b(i)=rgb3((i-1)*3+3)
       end do
!
!
       open(7,file='ppmg.pgm')
       write(7,*) 'P2'
       write(7,*) m,n
       write(7,*) max
       do i=1,mn
       if((r(i).eq.0.).and.(g(i).eq.0.).and.(b(i).eq.0.)) then
               write(7,*) 0
       else
       write(7,*) r(i)/2.+128.-b(i)/2.
       end if
       end do
       close(7)
!
!
!
!
!
          end
!
